-- CONSULTA DE RECEITAS DIRETAS DA TELA
select
    cast(nt.numdocumento as varchar(100)) as numero_nota,
    nt.dtentradasaida as data,
    cast(pes.nome as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(ni.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(pat.numero as varchar(30)) as numero_patrimonio,
    cast(pat.descricao as varchar(50)) as nome_patrimonio,
    cast('' as varchar(30)) as safra,
    cast(ati.nome as varchar(40)) as atividade,
    cast(100 as decimal(3,2)) as percentual,
    cast(((ni.vrtotal / 100)*100) as decimal(15,2)) as valor_apropriado
from
    notaitem ni
    join nota nt on nt.cdnota = ni.cdnota
    join produto pr on pr.cdproduto = ni.cdproduto
    join contagerencial cg on cg.cdcontagerencial = ni.cdcontagerencial
    join pessoa pes on pes.cdpessoa = nt.cdpessoa
    join patrimonio pat on pat.cdpatrimonio = ni.cdpatrimonio
    left join atividade ati on ati.cdatividade = ni.cdatividade
where
    nt.dtentradasaida>='2022-08-01' and
    nt.dtentradasaida<='2030-12-31' and
    nt.tiponota = 'S'
    and ni.saidaimediata = '0'
   
UNION ALL

-- CONSULTA DE RECEITAS DE PRODUÇÃO
select
    cast('Estoque' as varchar(100))as numero_nota,
    mo.data as data,
    cast('Estoque' as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(mo.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(pat.numero as varchar(30)) as numero_patrimonio,
    cast(pat.descricao as varchar(50)) as nome_patrimonio,
    cast('' as varchar(30)) as safra,
    cast(ati.nome as varchar(40)) as atividade,
    cast(100 as decimal(3,2)) as percentual,
    cast(mo.vrtotal as decimal(15,2)) as valor_apropriado
from
    movimentoestoque mo
    join produto pr on pr.cdproduto = mo.cdproduto
    join contagerencial cg on cg.cdcontagerencial = mo.cdcontagerencial
    join patrimonio pat on pat.cdpatrimonio = mo.cdpatrimonio
    left join atividade ati on ati.cdatividade = mo.cdatividade
where
    mo.cdtipomovimentoestoque = 4 and
    mo.data>='2022-08-01' and
    mo.data<='2030-12-31' 

UNION ALL

-- CONSULTA DE CUSTOS A PARTIR DAS SAÍDAS DE ESTOQUE
select
    cast('Estoque' as varchar(100))as numero_nota,
    mo.data as data,
    cast('Estoque' as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(mo.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(pat.numero as varchar(30)) as numero_patrimonio,
    cast(pat.descricao as varchar(50)) as nome_patrimonio,
    cast('' as varchar(30)) as safra,
    cast(ati.nome as varchar(40)) as atividade,
    cast(100 as decimal(3,2)) as percentual,
    cast((((select customedio from sp_customedio(mo.data,mo.cdproduto)) * mo.qtde) * -1) as decimal(15,2)) as valor_apropriado
from
    movimentoestoque mo
    join produto pr on pr.cdproduto = mo.cdproduto
    join contagerencial cg on cg.cdcontagerencial = mo.cdcontagerencial
    join patrimonio pat on pat.cdpatrimonio = mo.cdpatrimonio
    left join atividade ati on ati.cdatividade = mo.cdatividade
where
    mo.cdtipomovimentoestoque in (7,8,9,10) and
    mo.data>='2022-08-01' and
    mo.data<='2030-12-31' 

UNION ALL

-- CONSULTA DE CUSTOS A PARTIR DA TELA DE DESPESAS
select
    cast(nt.numdocumento as varchar(100)) as numero_nota,
    nt.dtentradasaida as data,
    cast(pes.nome as varchar(100)) as fornecedor,
    cast(pr.numero as varchar(30)) as numero_produto,
    cast(pr.nome as varchar(100)) as nome_produto,
    cast(ni.qtde as real) as quantidade,
    cast(cg.numero as varchar(30)) as numero_conta,
    cast(cg.descricao as varchar(50)) as nome_conta,
    cast(pat.numero as varchar(30)) as numero_patrimonio,
    cast(pat.descricao as varchar(50)) as nome_patrimonio,
    cast('' as varchar(30)) as safra,
    cast(ati.nome as varchar(40)) as atividade,
    cast(100 as decimal(3,2)) as percentual,
    cast((((ni.vrtotal / 100)*100) * -1) as decimal(15,2)) as valor_apropriado
from
    notaitem ni
    join nota nt on nt.cdnota = ni.cdnota
    join produto pr on pr.cdproduto = ni.cdproduto
    join patrimonio pat on pat.cdpatrimonio = ni.cdpatrimonio
    join contagerencial cg on cg.cdcontagerencial = ni.cdcontagerencial
    join pessoa pes on pes.cdpessoa = nt.cdpessoa
    left join atividade ati on ati.cdatividade = ni.cdatividade
where
    nt.dtentradasaida>='2022-08-01' and
    nt.dtentradasaida<='2030-12-31' and
    nt.tiponota = 'E' and
    ((nt.tipofiscal = 'N' and nt.cdnota not in (select re.cdnotavinculada from nota re where re.cdnotavinculada is not null)) or (nt.tipofiscal = 'I') )
    and ni.saidaimediata = '0'
    

    order by 2